-- Player BaseClass

-- The whole point of this structure is to focus on one place at a time. 
-- This file will load the things the player needs. 

	local idleSheet = lg.newImage("idle.png")
	local walkSheet = lg.newImage("walk.png")
	local crouchSheet = lg.newImage("crouch.png")	
	local grabSheet = lg.newImage("grab.png")	
	local jumpSheet = lg.newImage("jump.png")	
	local landSheet = lg.newImage("land.png")	
	local kickSheet = lg.newImage("kick.png")	
	local slamSheet = lg.newImage("slam.png")	
	
	local xanIdle = newAnimation( idleSheet, 128, 128, 0.1, 0)
	local xanWalk = newAnimation( walkSheet, 150, 128, 0.1, 7)
	local xanCrouch = newAnimation( crouchSheet, 128, 128, 0.2, 0)
	local xanGrab = newAnimation( grabSheet, 150, 150, 0.1, 0)
	local xanJump = newAnimation( jumpSheet, 128, 180, 0.15, 0)
	local xanLand = newAnimation( landSheet, 128, 180, 0.15, 4)
	local xanKick = newAnimation( kickSheet, 256, 128, 0.1, 0)
	local xanSlam = newAnimation( slamSheet, 128, 128, 0.1, 0)

	
	-- new animations kick and slam work! now let's integrate? 
	
	-- actually let's focus on what's not flying right. Before we take this sad bastard off the ground. 

	

	
	

xan = {     
		pos = {	
				x = lg.getWidth()/5 , -- based on screen size
				y = lg.getHeight()/2 
			  },
				
		drawVars = {				
				rot = 0, -- draw vars
				sx = 1,
				sy = 1,
				xo = 64,
				yo = 115,
				   },
		
		speed = 5, -- default 190 --Config Vars (speed == velX, jspd = velY .... REMEMBR IT!
		jspd = 0, -- to be incremented by accel. and decremented by gravity. 
		aspd = 10, -- airspeed
		jsmx = 20, -- the maximum speed of jumps
		jhgt = 400,
		jacl = 5,
		
		state = "idle", --Default States
		facing = "right",
		grab = false, -- is grabbing
		jump = false, -- is jumping
		slam = false, -- is slamming 
		canJump = true, -- Xan can only jump when his feet are on the ground.
		canSlam = true,
		canKick = true, -- default vaules for abilities. 
		canFlip = true, -- can the player flip from side to side? 
		

		}

function xan:update(dt)

	xan:checkCollision()
	xan:checkState(dt) -- includes inputs
	
	
	if xan.state == "land" then  -- this takes away from the jspd. 
		xan.jspd = xan.jspd - xan.jacl
		if xan.jspd <= 0   then
			xan.jspd = 0
		end
	end 



end 

function xan:draw() -- changes the animation depending on the state. 
	
	if xan.state == "crouch" then
		xanCrouch:draw(xan.pos.x, xan.pos.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo)
	end
	
	if xan.state == "grab" then
		xanGrab:draw(xan.pos.x, xan.pos.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo)
	end
	
	if xan.state == "idle" then    --- this section actually is working with the animation switches. 
		xanIdle:draw(xan.pos.x, xan.pos.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo)
	end
	
	if xan.state == "walk" then
		xanWalk:draw(xan.pos.x, xan.pos.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo)
	end

	if xan.state == "jump" then
		xanJump:draw(xan.pos.x, xan.pos.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo + 30)
	end	
	
	if xan.state == "land" then
		xanLand:draw(xan.pos.x, xan.pos.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo + 30) -- adjust for image size 
	end
	
	if xan.state == "kick" then
		xanKick:draw(xan.pos.x, xan.pos.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo ) -- adjust for image size 
	end
	
	if xan.state == "slam" then
		xanSlam:draw(xan.pos.x, xan.pos.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo ) -- adjust for image size 
	end

	
	--debug to show origin
	love.graphics.circle("fill", xan.pos.x, xan.pos.y, 5)
	
end 

function xan:Slam()
	-- this is triggered when you are grabbing a rock and you decide to jump. The animation 
	-- is in the file. Well.. it will be. .... 
	-- Right now collision is causing a problem with the jump height.
	local smax = 200
	local sSpeed = 60
	
	if xan.canSlam then
		xan.state = "slam"
		xan.canJump = true -- this stops the slam from repeating. 
		
		if checkHit(xan,rock) and xan:checkSides() and xan.slam==false then 
			xanSlam:seek(1)
			rock.pos.x = xan.pos.x + (10 * xan.drawVars.sx)
			rock.pos.y = xan.pos.y - rock.drawVars.xo
			xan.pos.y = xan.pos.y - sSpeed

		end
		
		if xan.pos.y <= smax then
			xanSlam:seek(2)
			xan.slam = true 
			rock.pos.x = xan.pos.x + (10 * xan.drawVars.sx)
			rock.pos.y = xan.pos.y + rock.drawVars.yo
			xan.pos.y = xan.pos.y + sSpeed
		end
		
		if xan.slam == true and xan.pos.y >= groundLevel then
			rock.Slam() -- fake Destroy of rock. Using the same method that we want in the future. 
			xan.Jump()
		end
		
	end
	
end 

function xan:Grab()

	xan.state = "grab"
	xan.canFlip = false

	local gripx = xan.pos.x +(xan.drawVars.sx*60) -- looks pretty good for now. 
	local gripy = xan.pos.y - 30 -- it's close.. 
	
	if checkHit(xan,rock) 
		and xan:checkSides() then -- move this to the grab function. 
	-- wait to move the rock until animation is completed .. then hold animation. 
		if xanGrab:getCurrentFrame() == 4 then
			xanGrab:seek(4)
			xan.grab = true -- first activate the switch. it can act as a filter against other statements. 
			rock.pos.x = gripx
			rock.pos.y = gripy
		end
	end

end

function xan:Jump() -- remember the Capitol methods. Jump,Slam,Bite.. what have you. 
	
	local jmax = groundLevel - xan.jhgt 
	local topXan = xan.pos.y - xan.drawVars.yo
	
	xan.canFlip = false -- so we dont flipscale in the air. 
	
	if xan.canJump then

		xan.jspd = xan.jspd + xan.jacl 
		xan.jump = true -- when we adjust the speed we are jumping
		xan.state = "jump"
		
		if topXan <= jmax then -- fall once we reach jump max. 
			xan.canJump = false
			xan.jump = false
		end		
		
		if xan.jspd >= xan.jsmx then 
			xan.jspd = xan.jsmx -- limit the jump speed 
		end
		xan.Move()
		xan.pos.y = xan.pos.y - xan.jspd
	end
	-- at the end we update xan y pos with the results from above. 
	-- we need to multiply this by the /limit to get a nice curve. 


end 


function xan:Move() --- should be the only place where we move XAN. ( in the x? 

	if xan.state == "idle" then
		xan.state = "walk" 
	end
		
	xan.pos.x = xan.pos.x +(xan.drawVars.sx * xan.speed) -- move xan. according to facing scale. 
end 

function xan:Crouch()
	xan.state = "crouch"
end

function xan:Kick()

	xan.state = "kick"

end


function love.mousereleased(x, y, btn)

	if btn == 'l' then 
		xan.jump = false
		xan.canJump = false
		xan.canFlip = true
		
		xan.slam = false
		xan.canSlam = true -- because you need this button to do it. 
		
		xan.state = "land" --- it's the only place i want to see it. 
		xanLand:seek(1)
		xanJump:seek(1) -- we seek the animation so it always starts at the beginning when we release the mouse.
	end
	
	if btn == 'r' then
		xan.grab = false -- reset xan state and animation on release. 
		xanGrab:seek(1)
		xanKick:seek(3)
		xan.canFlip = true
	end
	
end 

-- also seems to check input. 
function xan:checkState(dt)

	local mx = love.mouse.getX() -- mouse position
	local my = love.mouse.getY()
	
	xan:updateGravity()
	xan:checkLand() -- stop that bounce 
	

--needs to be organized in a state switch like the animations. Since xan can only be in one state at a time. That's what we want. 
	if love.mouse.isDown('r') and love.mouse.isDown('l') then 
		xan.Slam()
	elseif xan.pos.y == groundLevel and xan.pos.y < my and love.mouse.isDown('r') then 
		xan.state = "kick"
		--xan.Kick() -- make sure that he can kick if he's not touching. And we can also set scaling to false. 
	elseif love.mouse.isDown('l') then 
		xan.Jump()
	elseif love.mouse.isDown('r') and xan.state == "idle" then
		xan.Grab()
	elseif blocked == false and xan.jump == false then 
		xan.Move()
	elseif xan.pos.y < groundLevel and xan.jump == false then
		xan.state = "land"
	elseif blocked then
		xan.state = "idle" 
		xan.canJump = true -- so we can jump once we land
	end
	
	if xan.pos.y < my and xan.state == "idle" then
			xan.Crouch() -- may as well.. follow Suit. 
			--xan.state = "crouch"
	end
	

	

--update Facing Scale if we are allowed to. 

	if xan.canFlip then 
		if xan.pos.x > mx then -- mouse is left of xan. 
			xan.drawVars.sx = -1 -- xan is facing left. 
			xan.facing = "left"
		elseif xan.pos.x < mx then 
			xan.drawVars.sx = 1
			xan.facing = "right"
		end
	end

		
-- animation State handling ( Switch Animations ) --- good for when we want one thing at a time. 
	if xan.state == "idle" then 
		xanIdle:update(dt) -- updates animation
	elseif xan.state == "walk" then
		xanWalk:update(dt) 
	elseif xan.state == "crouch" then
		xanCrouch:update(dt) 
	elseif xan.state == "grab" then
		xanGrab:update(dt) 
	elseif xan.state == "jump" then
		xanJump:update(dt) 
	elseif xan.state == "kick" then
		xanKick:update(dt) 
	elseif xan.state == "land" then
		xanLand:update(dt) 
	end



end 


function xan:checkCollision ()

	local mx = love.mouse.getX() 
	local my = love.mouse.getY()
	local topRock = rock.pos.y - rock.drawVars.yo 
	local sideRock = 30 -- rock thickness to compensate for box collision.  
	

-- conditions that cause xan to be blocked. 
	if mx >= xan.pos.x - xan.drawVars.xo 
		and mx <= xan.pos.x + xan.drawVars.xo then 
		
			blocked = true
	else
			blocked = false
	end
	
	if checkHit(xan,rock) then  
	
			blocked = true
	end

-- conditions that cause xan to be free. 
	if checkHit(xan,rock) 
		and xan.pos.y < topRock then --- xan hits above top of rock.
		
			blocked = false
	end
	

	--Keep track of facing so his butt doesn't get stuck to the rock. 
	if xan.facing == "left" 
		and checkHit(xan,rock) 
		and xan.pos.x  < rock.pos.x then
		
			blocked = false
			
	elseif xan.facing == "right" 
		and checkHit(xan,rock) 
		and xan.pos.x > rock.pos.x then
		
			blocked = false
	end 
	
-- let's try to land on a boulder. [[BROKEN????]]
	if checkHit(xan,rock) 
		and xan.pos.y < topRock then 
		
			xan.blocked = false -- so now when xan is on top 
			xan.jump = false -- stop the force of gravity?	
	end
	

end


-- check to see if Xan is facing the rocks.  
function xan:checkSides()

	if xan.facing == "right" and xan.pos.x < rock.pos.x then
		return true
	elseif xan.facing == "left" and xan.pos.x > rock.pos.x then
		return true
	else 
		return false
	end
	

end



function xan:updateGravity()
	-- lets get the move back first. 
	if xan.jump == false then -- apply gravity. 
		xan.pos.y = xan.pos.y + grav
	end
	
	if xan.pos.y >= groundLevel then 
		xan.pos.y = groundLevel
	end
	
end	

function xan:checkLand()

	if xan.pos.y >= groundLevel then
		xan.state = "idle"
	end 
	
end 