--rock Class 
-- holds default values and methods for the rock

-- let's add the class structure to these files. 

require("class.lua")

boulder = lg.newImage("rock.png")

--Button = class(function(obj, text, x, y)<paramAssignment> end) -- remember we can make a class this way. 
-- obj is the first arg in the function in class. This gives us "class behaviors" like defining methods using 
-- self for instances of the rock in the future. 
	

---[[
newRock = class(function(obj, x, y, weight) -- this is the definition of the function that will create the rocks. 

	-- 
	obj.x = x
	obj.y = y
	obj.weight = weight
	obj.state = "rest" -- this is for fun physics. 
	
	--obj.img = ( Derived from weight -- will lead to xan being able to lift a rock. Expect mass change.
	
	--drawVars -- container we pass to the draw function. WE also use them for collision. 
	--[[
	obj.drawVars = {
		x = self.x,
		y = self.y,
		xo = self.img.getWidth()/2, -- offset is rather important to this system.
		yo = self.img.getHeight(),
		sx = 1,
		sy = 1,
		rot = 0, -- we can make these more dynamic later. 
	
	}
	
	--]]


end)
--]]
-- we need to keep the xan references the same. And make sure we change the rock. references to self.property. 
--[[
function rock:draw()

	lg.draw(rock.img, rock.pos.x, rock.pos.y, rock.drawVars.rot,rock.drawVars.sx, rock.drawVars.sy, rock.drawVars.xo, rock.drawVars.yo)
--shape at rock origin
	lg.circle("fill",rock.pos.x, rock.pos.y, 5)
	
	
end

function rock:Slide()
		-- we want to get xans scale one time. This function is repeated until the rock state is changed. 
		la.play(slide)
		rock.pos.x = rock.pos.x + (rock.sSpeed * xan.drawVars.sx)

end

function rock:Slam()

		rock.pos.y = -50 -- for now we'll put the rock above the screen. I want to come back and make this class rock. 
		rock.pos.x = lg.getWidth()/2  
		rock.state = "rest"
		
		-- the main fill will be the game state machine so score will be global.
		addPoints(rock.value)
		
end





--]]


 -- for now we're using the singleton rock. 

---[[ -- this is the old rock constructor. It's going to be obsolete fast. 
rock = { 
		img = boulder ,  -- the rock constructor will have different images.. Depending of course on the arg it gets. 
		weight = 1, 
		pos = {x = 256, y = -40},
		drawVars = { xo = 32,
					 yo = 64,
					 sx = 1, -- collision doesn't multiply with scale. It's based on offset
					 sy = 1,
					 rot = 0,
					},
		sSpeed = 10 , -- default value
		state = "rest",
		value = 500, -- points... of course. -- is default value. Can mod. 
			
		
		}
--]]
		
function rock:update(dt)
	
	
	local frict = 1

	--rock.sSpeed = (25/rock.weight) -- simple DIY algorithm. Lets slow down there 
	if xan.state == "kick" and checkHit(xan,rock) then
		rock.state = "slide"
	end
	
	if rock.state == "slide" then
		rock.Slide() -- this function is right. But isn't called in the right way. 
	end
	
	if rock.state == "rest" then
		rock.pos.x = rock.pos.x
		rock.pos.y = rock.pos.y
	end
	
	--keep the rock on stage. 
	local edgeRight = rock.pos.x + rock.drawVars.xo
	local edgeLeft = rock.pos.x - rock.drawVars.xo
	
	if edgeRight + rock.sSpeed > lg.getWidth() then -- hits edge of the screen. 
		rock.pos.x = lg.getWidth() - rock.drawVars.xo
		rock.state = "rest"
	elseif edgeLeft - rock.sSpeed < 0 then -- hits edge of the screen. 
		rock.pos.x = rock.drawVars.xo
		rock.state = "rest"
	end

	-- update rock gravity. 
	if rock.pos.y < groundLevel then
		rock.pos.y = rock.pos.y + grav
	
	end
	

end

function rock:draw()

	lg.draw(rock.img, rock.pos.x, rock.pos.y, rock.drawVars.rot,rock.drawVars.sx, rock.drawVars.sy, rock.drawVars.xo, rock.drawVars.yo)
--shape at rock origin
	lg.circle("fill",rock.pos.x, rock.pos.y, 5)
	
	
end

function rock:Slide()
		-- we want to get xans scale one time. This function is repeated until the rock state is changed. 
		la.play(slide)
		rock.pos.x = rock.pos.x + (rock.sSpeed * xan.drawVars.sx)

end

function rock:Slam()

		rock.pos.y = -50 -- for now we'll put the rock above the screen. I want to come back and make this class rock. 
		rock.pos.x = lg.getWidth()/2  
		rock.state = "rest"
		
		-- the main fill will be the game state machine so score will be global.
		addPoints(rock.value)
		
end
